unit ATSR200;
{ unite de pilotage de la regulation de temperature TANE/ATSR200 }
{ le pilotage de ce bazar par GPIB est aussi confus que en live  }
{ Mise a jour: F. OTT     le 28.10.99                            }
{ bug : les commandes ne sont renvoyes qu'apres avoir envoy l'ordre par deux fois }
{ c'est li a un plobleme de vitesse, si on enchaine les commandes a la suite dans le code }
{ la reponse ne passe pas dans le buffer et on recupere la reponse a la commande precedente ! }
{ il semble hors de question de mettre une temporisation                                    }
{ SOLUTION : on teste le type de la reponse!                                           }

{ sur ce machin il n'y a qu'une lecture de rsistance }
{ il faudra rentrer une table de conversion qqe part  }
{ et prciser aux fonctions quel est le type de capteur utilis }
{ ces fonctions se chargeront de la conversion          }

{ a faire: configuration du controleur a partir du programme }

interface

uses GPIB_CEC;

{ priv }
function TestSend_ATSR200(s1:string;adresse:byte;channel:byte):real;
function TestReceive_ATSR200(s1:string;adresse:byte;channel:byte):real;
{ public }
function ReadTemperature_ATSR200(adresse:byte;channel:byte):real;
procedure SetTemperature_ATSR200(adresse:byte;channel:byte;value:real);
function IsTemperatureStable_ATSR200(adresse:byte;channel:byte):boolean;

implementation

{ procedure de test d'envoi de chaines pour valider les sequences }
function TestSend_ATSR200(s1:string;adresse:byte;channel:byte):real;
var s:string;
    l:word;
    status,errorCode:integer;
    value:real;
begin
{    GPIBSend(adresse,s1,status);writeln(status); }
    GPIBSend(adresse,s1);
end;

{ procedure de test d'envoi de chaines pour valider les sequences }
function TestReceive_ATSR200(s1:string;adresse:byte;channel:byte):real;
var s:string;
    l:word;
    status,errorCode:integer;
    value:real;
begin
{    GPIBRead(s,255,l,adresse,status);writeln(status); }
    GPIBRead(adresse,s,255);
    writeln(s);
end;


{ lecture de la temperature sur ATNE/ATSR200                }
{ INPUT: adresse: l'adresse du controlleur                  }
{        channel: channel de lecture                        }
{        pour les canaux canal1- =0; canal1+ = 1            }
{                        canal2- =2; canal2+ = 3 ...etc...  }
{        + et - indiquant le signe du coeff de temp         }
{ OUTPUT: real: la temperature en ohms (pour le moment)     }
{ REMARKS: pour le moment on ne fait que de la lecture      }
{          cette procedure passe en suiveur automatiquement }
function ReadTemperature_ATSR200(adresse:byte;channel:byte):real;
var s:string;
    l:word;
    status,errorCode:integer;
    value:real;
begin
{ selection du channel }
   str(channel,s);
{ GPIBSend(adresse,'WE'+s,status); }
{ passage en mode suiveur ACHTUNG! }
{    GPIBSEND(adresse,'WS',status); }
    GPIBSEND(adresse,'WS');
{ lecture de la temperature }
{    GPIBSend(adresse,'RB',status); }
    GPIBSend(adresse,'RB');
    repeat
{          GPIBRead(s,255,l,adresse,status);writeln(status); }
          GPIBRead(adresse,s,255);
          { writeln(s);writeln(s[1]); }
    until s[1]='B';
{ extraction de la temperature dans le programme de test }
{ la chaine est renvoye avec 1 caractre B }
{    val(copy(s,2,l-1),value,errorCode); }
{ quand l'unit ets incluse dans le programme de pilotage de PRISM on lit BB123 }
{ cause inconnue }
    val(copy(s,3,l-1),value,errorCode);
    writeln(value:8:3);
    ReadTemperature_ATSR200:=value;
end;

{ lancement d'une consigne de temprature                   }
{ INPUT: adresse: l'adresse du controlleur                  }
{        channel: channel de lecture                        }
{        pour les canaux canal1- =0; canal1+ = 1            }
{                        canal2- =2; canal2+ = 3 ...etc...  }
{        + et - indiquant le signe du coeff de temp         }
{        value: temprature  atteindre (en ohms pour le moment }
{ OUTPUT:                                                       }
procedure SetTemperature_ATSR200(adresse:byte;channel:byte;value:real);
var s:string;
    l:word;
    status,errorCode:integer;
begin
{ il ne faut pas etre en mode SUIVEUR }
{ lecture du signal d'erreur }
{    GPIBSend(adresse,'RA',status);
    GPIBRead(s,255,l,adresse,status); }
    GPIBSend(adresse,'RA');
    GPIBRead(adresse,s,255);
    writeln(s);
    val(copy(s,2,l-1),value,errorCode);
    writeln(value:8:3);
end;

{ verification du signal d'erreur                           }
{ INPUT: adresse: l'adresse du controlleur                  }
{        channel: channel de lecture                        }
{        pour les canaux canal1- =0; canal1+ = 1            }
{                        canal2- =2; canal2+ = 3 ...etc...  }
{        + et - indiquant le signe du coeff de temp         }
{ OUTPUT: boolean : la temperature est stable ou non        }
{ REMARK: on considere que la temperature est stable quand le signal d'erreur }
{         est inferieur a 1% de sa pleine echelle                             }
function IsTemperatureStable_ATSR200(adresse:byte;channel:byte):boolean;
var s:string;
    l:word;
    status,errorCode:integer;
    value:real;
begin
{ il ne faut pas etre en mode SUIVEUR }
{ lecture du signal d'erreur }
{    GPIBSend(adresse,'RA',status);
    GPIBRead(s,255,l,adresse,status); }
    GPIBSend(adresse,'RA');
    GPIBRead(adresse,s,255);
    writeln(s);
    val(copy(s,2,l-1),value,errorCode);
    writeln(value:8:3);
    if (value-2038)<40
    then IsTemperatureStable_ATSR200:=True
    else IsTemperatureStable_ATSR200:=False;

end;

end.
