unit BOSS508;
{ unite de pilotage des alimentation TTI 10A              }
{ F. OTT, modifi le 27.10.99                             }
{ il y a des problmes de fonctionnement                  }
{ on ne peut pas envoyer les ordres trop vite...          }
{ 20.06.01 : FO : correction d'un bug dans SetVoltage     }
{            on peut maintenant demander des tensions negatives }

interface

uses Dialogs, GPIB_CEC,Windows,classes,Messages, SysUtils;

{ initialisation des alimentations }
Function Initialize_BOSS508(adresse:byte):integer;
{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: met la sortie de l'alimenation en pos active }
{         integer, code d'erreur                       }
Function SwitchON_BOSS508(adresse:byte):integer;
{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: met la sortie de l'alimenation en pos OFF    }
{         integer, code d'erreur                       }
Function SwitchOFF_BOSS508(adresse:byte):integer;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: integer, code d'erreur                       }
Function SetCurrentSource_BOSS508(adresse:byte):integer;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur de la tension VOLTS            }
{ OUTPUT: integer, code d'erreur                       }
Function SetVoltageSource_BOSS508(adresse:byte):integer;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: integer, code d'erreur                       }
Function SetCourant_BOSS508(adresse:byte;valeur:real):integer;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur de la tension VOLTS            }
{ OUTPUT: integer, code d'erreur                       }
Function SetTension_BOSS508(adresse:byte;valeur:real):integer;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: integer, code d'erreur                       }
Function GetCourant_BOSS508(adresse:byte):real;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur de la tension VOLTS            }
{ OUTPUT: integer, code d'erreur                       }
Function GetTension_BOSS508(adresse:byte):real;


implementation

const
     convI = 100/8; { facteur de conversion de courant en pourcents de full scale}
     convV = 100/50; { facteur de conversion de tension en pourcents de full scale}

{ initialisation des alimentations }
Function Initialize_BOSS508(adresse:byte):integer;
var status:integer;
begin
     GPIBSend(adresse,'SR'#13#10); { set remote }
     GPIBSend(adresse,'SI'#13#10); 
{     GPIBSend(adresse,'SV'#13#10); }
     GPIBSend(adresse,'SM1'#13#10); { passage en short output (pour les messages) }
end;

{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: met la sortie de l'alimenation en pos active }
{         integer, code d'erreur                       }
Function SwitchON_BOSS508(adresse:byte):integer; { ok }
var status:integer;
begin
     MessageDlg('Impossible d''allumer la BOSS508  distance, assignez une tension ou un courant', mtInformation,
      [mbOk], 0);
end;

{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: met la sortie de l'alimenation en pos OFF    }
{         integer, code d'erreur                       }
Function SwitchOFF_BOSS508(adresse:byte):integer;
var status:integer;
begin
     GPIBSend(adresse,'SV'); { passage en voltage control }
     GPIBSend(adresse,'PC%0'); { mise  zro de la tension }
     GPIBSend(adresse,'SI'); { passage en current control }
     GPIBSend(adresse,'PC%0'); { mise  zro du courant }
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: integer, code d'erreur                       }
Function SetCurrentSource_BOSS508(adresse:byte):integer;
begin
     GPIBSend(adresse,'SI'+#13#10);
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur de la tension VOLTS            }
{ OUTPUT: integer, code d'erreur                       }
Function SetVoltageSource_BOSS508(adresse:byte):integer;
begin
     GPIBSend(adresse,'SV'+#13#10);
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES  -8<I<+8 }
{ OUTPUT: integer, code d'erreur                       }
Function SetCourant_BOSS508(adresse:byte;valeur:real):integer;
var s,s1:string;
    status,i:integer;
    l:word;
begin
{ utiliser plutot le codage hexa, c'est plus simple a priori }
   s:=formatfloat('#0.###',valeur);
   GPIBSend(adresse,'PC'+s+#13+#10);

end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur de la tension VOLTS            }
{ OUTPUT: integer, code d'erreur                       }
Function SetTension_BOSS508(adresse:byte;valeur:real):integer;
var s:string;
    i,status:integer;
begin
{ utiliser plutot le codage hexa, c'est plus simple a priori }
{   str(valeur,s);
      GPIBSend(adresse,'PC'+s+#13#10) }
   s:=formatfloat('#0.###',valeur);
   GPIBSend(adresse,'PC'+s+#13+#10);
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: integer, code d'erreur                       }
Function GetCourant_BOSS508(adresse:byte):real;
var s:string;
    status:integer;
begin
{     GPIBSend(adresse,'MI');  lecture de la tension }
{     s:=GPIBRRead(adresse,'MV',status);  lecture de la tension }
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur de la tension VOLTS            }
{ OUTPUT: integer, code d'erreur                       }
Function GetTension_BOSS508(adresse:byte):real;
var s:string;
    status:integer;
begin
     GPIBSend(adresse,'MV'); { lecture de la tension }
{     GPIBRRead(adresse,'MV',status); { lecture de la tension }
end;


end.
