unit ITC4drv;
{ la communication avec l'ITC4 n'est pas sans faille }
{ si on envoie une serie de commandes, certaines finissent pas ne plus repondre }
{ SOLUTION: utiliser flushbuffer avant toute operation                          }
{ Probleme: on ne locke pas Remote/Local      }
{           cependant si l'utilisateur passe en local,  et oublie d'y revenir on est dans la merde }
{           car on envoie pas sytmatiquement de C3                                                }
{ prevoir une fonction Remote }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Comrs232, StdCtrls, Spin, EditReal; {, ComDrv32, ComRS232str; }

type
  TITC4 = class(TForm)
    StringToSend: TEdit;
    SendButton: TButton;
    memo1: TMemo;
    CommPortDriver1: TCommPortDriver;
    ReadTemp: TButton;
    Display: TButton;
    Regulation: TButton;
    SetPoint: TButton;
    SetP: TButton;
    GetStatusButton: TButton;
    TempBox: TEditReal;
    SetTempBox: TEditReal;
    GainPbox: TEditReal;
    ChannelBox: TSpinEdit;
    Label1: TLabel;
    procedure CommPortDriver1ReceiveData(Sender: TObject;s:string;
      DataSize: Integer);
    procedure DisplayClick(Sender: TObject);
    procedure SendButtonClick(Sender: TObject);
    procedure StringToSendKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ReadTempClick(Sender: TObject);
    procedure RegulationClick(Sender: TObject);
    procedure SetPointClick(Sender: TObject);
    procedure SetPClick(Sender: TObject);
    procedure GetStatusButtonClick(Sender: TObject);
      private
      FTempInBuffer              : pointer;
    { envoi d'une chaine et lecture sur l'ITC4 }
    function sendread(su:string):string;
    { Dclarations prives }
  public
    { Dclarations publiques }
    { lecture du status de l'ITC4 }
    function GetStatusA:byte;
    function GetStatusC:byte;
    function GetStatusS:byte;
    { passage en rgulation automatique (pour le heater) }
    procedure SetHeaterAuto_ITC4;
    { passage en rgulation automatique (pour la NV) }
    procedure SetGazFlowAuto_ITC4;
    { passage en rgulation automatique (pour le heater) }
    procedure SetHeaterManual_ITC4;
    { passage en rgulation automatique (pour la NV) }
    procedure SetGazFlowManual_ITC4;
    { definition du gain P en pourcents }
    procedure SetProportionnal_ITC4(p:real);
    { definition du gain I en pourcents }
    procedure SetIntegral_ITC4(i:real);
    { definition du gain P en pourcents }
    procedure SetDerivative_ITC4(d:real);
    { lecture de la temprature sur le channel "channel", OUTPUT en kelvin }
    function readTemperature_ITC4(channel:byte):real; { ok }
    { change le display de l'affichage sur un des toris canaux de lecture }
    procedure DisplayTemperature_ITC4(channel:byte); { ok }
    { choix du channel pour la regulation }
    procedure SetRegulationChannel_ITC4(channel:byte);
    { definition d'un SetPoint }
    procedure setTemperature_ITC4(Temp:real);
    { ouverture de la needle valve }
    procedure setGazFlow_ITC4(opening:byte);

  end;

var
  ITC4: TITC4;
  xtc:boolean; { quoi qu'est-ce? }

implementation

{$R *.DFM}

{ initialisation de la connection et verification si l'ITC4 est allum }
procedure TITC4.FormCreate(Sender: TObject);
var s:string;
begin
  xtc:=true;
  GetMem( FTempInBuffer,10);
  commportdriver1.connect;
  commportdriver1.FlushBuffers(true,true);
  s:=sendread('C3'+#13);
  if s[1]<> 'C' then begin messagebox(handle,'ITC4 non prsent','Attention!',mb_ok);                              end;
end;

procedure TITC4.FormDestroy(Sender: TObject);
begin
  commportdriver1.Disconnect;
  FreeMem( FTempInBuffer,10);
end;

{ pourquoi faut-il redefinir cette procedure ici ??? }
procedure TITC4.CommPortDriver1ReceiveData(Sender: TObject;
  s:string; DataSize: Integer);
var
s1:string[2];
begin
s1:=copy(s,length(s),1);
s:=copy(s,1,length(s)-1);
if s1=#6 then s:=s+' :ack';
if s1=#21 then s:=s+' :nack';
memo1.lines.add(s);
end;

{ procdure criture/lecture sur l'ITC4 }
{ INPUT: su, chaine a envoyer           }
{ OUTPUT: la chane de rponse          }
{ N.B. aprs les chaines utiles, il y a des caractres supplmentaires qui arrivent !!! }
{ il ne faut pas en tenir compte }
function TITC4.sendread(su:string):string;
var
u:integer;
p:pchar;
s1:string[1];
s:string;
u1,u2:double;
fin:boolean;
begin
{  s:=su+#13;            { WHY?, c'est deja rajout dans les chaines envoyes au bidule }
  s:=su;
  commportdriver1.SendData( pchar(s),length(s));
  s:='';u:=1;fin:=false;s1:='1';
  { lecture de la chane recue }
  u1:=time; { 0.0001 est le timeout }
  while (u1+0.0001>time) and (s1[1]<>#13) and (s1[1]<>#10) do
  begin
    u:=_hread(commportdriver1.comhandle,@Ftempinbuffer^,1);
    if u>0 then
        begin
          p:=Ftempinbuffer;s1:=strpas(p);
          s:=s+s1[1];
        end;
  end;
  if length(s)>0 then result:=s else result:='timeout';
end;

{ =========================================================== }
{ procdures gnrales de pilotage de l'ITC4                  }
{ =========================================================== }

{ lecture du status de l'ITC4 }
{ INPUT: none                 }
{ OUTPUT: An, defining the AUTO/MAN status }
function TITC4.GetStatusA:byte;
var
   ca:string;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   s:='aa';
   while s[1]<>'X' do begin s:=sendread('X'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
   GetStatusA:=round(strtofloat(copy(s,4,1)));
end;

{ lecture du status de l'ITC4 }
{ INPUT: none                 }
{ OUTPUT: Cn, defining the Lock/Rem status }
function TITC4.GetStatusC:byte;
var
   ca:string;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   s:='aa';
   while s[1]<>'X' do begin s:=sendread('X'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
   GetStatusC:=round(strtofloat(copy(s,6,1)));
end;

{ lecture du status de l'ITC4 }
{ INPUT: none                 }
{ OUTPUT: Sn, defining the Sweep status }
function TITC4.GetStatusS:byte;
var
   ca:string;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   s:='aa';
   while s[1]<>'X' do begin s:=sendread('X'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
   GetStatusS:=round(strtofloat(copy(s,8,2)));
end;

{ passage en rgulation automatique (pour le heater) }
{ on laisse la regul NV dans l'tat ou elle tait }
procedure TITC4.SetHeaterAuto_ITC4;
var s:string;
    An:byte;
begin
   An:=GetStatusA;
   commportdriver1.FlushBuffers(true,true);
   s:='aa';
   case An of
      0:while s[1]<>'A' do begin s:=sendread('A1'+#13)  end;
      1:while s[1]<>'A' do begin s:=sendread('A1'+#13)  end;
      2:while s[1]<>'A' do begin s:=sendread('A3'+#13)  end;
      3:while s[1]<>'A' do begin s:=sendread('A3'+#13)  end;
   end;
   memo1.lines.add(s);
end;

{ passage en rgulation automatique (pour la NV) }
procedure TITC4.SetGazFlowAuto_ITC4;
var s:string;
    An:byte;
begin
   An:=GetStatusA;
   commportdriver1.FlushBuffers(true,true);
   s:='aa';
   case An of
      0:while s[1]<>'A' do begin s:=sendread('A2'+#13)  end;
      1:while s[1]<>'A' do begin s:=sendread('A3'+#13)  end;
      2:while s[1]<>'A' do begin s:=sendread('A2'+#13)  end;
      3:while s[1]<>'A' do begin s:=sendread('A3'+#13)  end;
   end;
   memo1.lines.add(s);
end;

{ passage en rgulation manuelle (pour le heater) }
procedure TITC4.SetHeaterManual_ITC4;
var s:string;
    An:byte;
begin
   An:=GetStatusA;
   commportdriver1.FlushBuffers(true,true);
   s:='aa';
   case An of
      0:while s[1]<>'A' do begin s:=sendread('A0'+#13)  end;
      1:while s[1]<>'A' do begin s:=sendread('A0'+#13)  end;
      2:while s[1]<>'A' do begin s:=sendread('A2'+#13)  end;
      3:while s[1]<>'A' do begin s:=sendread('A2'+#13)  end;
   end;
   memo1.lines.add(s);
end;

{ passage en rgulation manuelle (pour la NV) }
procedure TITC4.SetGazFlowManual_ITC4;
var s:string;
    An:byte;
begin
   An:=GetStatusA;
   commportdriver1.FlushBuffers(true,true);
   s:='aa';
   case An of
      0:while s[1]<>'A' do begin s:=sendread('A0'+#13)  end;
      1:while s[1]<>'A' do begin s:=sendread('A1'+#13)  end;
      2:while s[1]<>'A' do begin s:=sendread('A0'+#13)  end;
      3:while s[1]<>'A' do begin s:=sendread('A1'+#13)  end;
   end;
   memo1.lines.add(s);
end;

{ definition du gain P en pourcents }
{ INPUT: gain P en pourcents avec 1 decimale significative }
{ OUTPUT: la valeur de la temprature (valeur relle en Kelvins)}
{ fonctionne correctement }
{ NB. suppose qu'on est configur avec 1 dcimale     }
procedure TITC4.SetProportionnal_ITC4(p:real); { ok }
var
   ca:string;
   p1:real;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   p1:=round(p*10);
   str(p1:4:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   while s[1]<>'P' do begin s:=sendread('P'+ca+#13)  end;
   memo1.lines.add(s);
end;

{ definition du gain I en pourcents }
{ INPUT: gain P en pourcents avec 1 decimale significative }
{ OUTPUT: la valeur de la temprature (valeur relle en Kelvins)}
{ fonctionne correctement }
{ NB. suppose qu'on est configur avec 1 dcimale     }
procedure TITC4.SetIntegral_ITC4(i:real); { ok }
var
   ca:string;
   i1:real;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   i1:=round(i*10);
   str(i1:4:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   while s[1]<>'I' do begin s:=sendread('I'+ca+#13)  end;
   memo1.lines.add(s);
end;

{ definition du gain D en pourcents }
{ INPUT: gain P en pourcents avec 1 decimale significative }
{ OUTPUT: la valeur de la temprature (valeur relle en Kelvins)}
{ fonctionne correctement }
{ NB. suppose qu'on est configur avec 1 dcimale     }
procedure TITC4.SetDerivative_ITC4(d:real); { ok }
var
   ca:string;
   d1:real;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   d1:=round(d*10);
   str(d1:4:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   while s[1]<>'D' do begin s:=sendread('D'+ca+#13)  end;
   memo1.lines.add(s);
end;

{ lecture de la temperature }
{ INPUT: channel, channel de lecture }
{ OUTPUT: la valeur de la temprature (valeur relle en Kelvins)}
{ fonctionne correctement }
{ NB. suppose qu'on est configur avec 1 dcimale     }
function TITC4.readTemperature_ITC4(channel:byte):real; { ok }
var
   ca:string;
   temp1:real;
   s:string;
begin
   if (channel>=1) and (channel<=3) then
   begin
   commportdriver1.FlushBuffers(true,true);
   str(channel,ca);
   s:='aa';
   while s[1]<>'R' do begin s:=sendread('R'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
   temp1:=strtofloat(copy(s,3,length(s)-3));
   result:=temp1/10; { facteur 10 depend des settings internes de l'ITC4)  }
   end
   else begin result:=9999;messagebox(handle,'Channel non disponible sur ITC4','Attention!',mb_ok) end;
end;

{ affichage de la temperature (sur l'ITC4) }
{ INPUT: channel, channel de display }
{ OUTPUT: none                       }
procedure TITC4.DisplayTemperature_ITC4(channel:byte); { ok }
var
   ca:string;
   temp1:real;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   str(channel,ca);
   s:='aa';
   while s[1]<>'F' do begin s:=sendread('F'+ca+#13) {;memo1.lines.add('rat'); } end;
   memo1.lines.add(s);
end;

{ choix du channel pour la regulation }
{ INPUT: channel, channel a partir duquel on va faire la regulation }
{ OUTPUT: none                       }
procedure TITC4.SetRegulationChannel_ITC4(channel:byte);
var
   ca:string;
   status:byte;
   s:string;
begin

{ il faut d'abord passe en manuel passage duheater et du gas flow en manuel }
   commportdriver1.FlushBuffers(true,true);
   s:='aa';
   while s[1]<>'A' do begin s:=sendread('A0'+#13)  end;
   memo1.lines.add(s);
{ changement du channel de regulation }
   commportdriver1.FlushBuffers(true,true);
   str(channel,ca);
   s:='aa';
   while s[1]<>'H' do begin s:=sendread('H'+ca+#13)  end;
   memo1.lines.add(s);
end;


{ ouverture de la needle valve }
{ INPUT: channel, channel a partir duquel on va faire la regulation }
{ OUTPUT: none                       }
procedure TITC4.setGazFlow_ITC4(opening:byte);
var
   ca:string;
   temp1:real;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   temp1:=round(opening);
   str(temp1:3:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   while s[1]<>'G' do begin s:=sendread('G'+ca+#13)  end;
   memo1.lines.add(s);
end;

{ definition d'un SetPoint }
{ INPUT: temp, temperature en Kelvin }
{ OUTPUT: on envoie la consigne  l'ITC4 }
procedure TITC4.setTemperature_ITC4(Temp:real);
var
   ca:string;
   temp1:real;
   s:string;
begin
   commportdriver1.FlushBuffers(true,true);
   temp1:=round(temp*10);
   str(temp1:4:0,ca);
   memo1.lines.add(ca);
   s:='aa';
   while s[1]<>'T' do begin s:=sendread('T'+ca+#13)  end;
   memo1.lines.add(s);
end;

{ ========================================================== }
{ procdures de test                                         }
{ ========================================================== }

procedure TITC4.DisplayClick(Sender: TObject);
var channel,i:integer;
    s,ca:string;
begin
     DisplayTemperature_ITC4(ChannelBox.value);
end;

procedure TITC4.SendButtonClick(Sender: TObject);
var
s:string;
s1:string[2];
begin
   commportdriver1.FlushBuffers(true,true);
   {  commportdriver1.connect; }
   s:=stringToSend.text;
   s:=sendread(s+#13);
{   memo1.lines.add(s+'X'); } { to vizualiaze the extra characters }
   s1:=copy(s,length(s),1);
   s:=copy(s,1,length(s)-1);
   if s1=#6 then s:=s+' :ack';
   if s1=#21 then s:=s+' :nack';
   memo1.lines.add(s);
   {commportdriver1.disconnect; }
end;


procedure TITC4.StringToSendKeyPress(Sender: TObject; var Key: Char);
var
s:string;
s1:string[2];
begin
if key=#13 then begin
s:=sendread(StringToSend.text+#13);
s1:=copy(s,length(s),1);
s:=copy(s,1,length(s)-1);
if s1=#6 then s:=s+' :ack';
if s1=#21 then s:=s+' :nack';
memo1.lines.add(s);
end;
end;

procedure TITC4.ReadTempClick(Sender: TObject);
begin
     TempBox.value:=ReadTemperature_ITC4(ChannelBox.value);
end;

procedure TITC4.RegulationClick(Sender: TObject);
begin
    SetRegulationChannel_ITC4(ChannelBox.value);
end;

procedure TITC4.SetPointClick(Sender: TObject);
begin
     SetTemperature_ITC4(SetTempBox.value);
end;

procedure TITC4.SetPClick(Sender: TObject);
begin
     SetProportionnal_ITC4(gainPbox.Value);
end;

procedure TITC4.GetStatusButtonClick(Sender: TObject);
var A,C,S:byte;
begin
     GetStatusA
end;

end.
