unit RMNacquisition;
{unit de prise du signal RMN et de son traitement pour combinaison avec le programme de pilotage PAPOL
fonctions hauts niveaux dans la gestion des cartes AT
traitement du signal et calcul de la polarisation
E.Leymarie 10/00
MODIFICATIONS :
17/11/00 : (edouard)
         Ajout d'une procdure RMNacqui.mesurepolar(n:integer;var polar,temps:real) pour liaison avec la fonction RMNlitpolar de l'interpreteur.
         Cration de la fonction RMNacqui.TestAcquis:boolean; pour tester la fin de l'acquisition RMN.  }
{27.03.01 : EL : modifications pour jumelage avec traitement:
                 modification spectre.addspectre(X,Y) en spectre.addspectre(X,Y,1)
                 modification data[x,y] en data[x,y,0]}
{28.11.01 : EL : Suppression de la translation de la base...
                 Ajout d'une possibilite de Fit par un polynome du signal de base avec MTxVec   }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls,editdata,AT_AOMIO,GPIB_CEC,PilotageManipMainForm,
  EditReal,MtxVec,polynoms;
type
    brut512=array[1..512] of longint;
const
    wm_redessine=$403+wm_user;

type
  TRMNacqui = class(TForm)
    GroupBox4: TGroupBox;
    Label16: TLabel;
    Label17: TLabel;
    Label15: TLabel;
    run: TButton;
    moy: TSpinEdit;
    npassage: TSpinEdit;
    index: TSpinEdit;
    Mode: TComboBox;
    Label1: TLabel;
    Label4: TLabel;
    repet: TSpinEdit;
    Label5: TLabel;
    Nbrspectres: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    duree: TEdit;
    base: TCheckBox;
    GroupBox1: TGroupBox;
    onsynthe: TButton;
    offsynthe: TButton;
    scansynthe: TButton;
    saturation: TButton;
    tsat: TEdit;
    Label8: TLabel;
    GroupBox2: TGroupBox;
    Timeracqui: TTimer;
    Label9: TLabel;
    sigpol: TComboBox;
    basepol: TComboBox;
    Label10: TLabel;
    Label11: TLabel;
    spectrepol: TComboBox;
    Label14: TLabel;
    stop: TButton;
    calpol: TCheckBox;
    affichespe: TCheckBox;
    freqmod: TEdit;
    Label22: TLabel;
    GroupBox3: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    freqg: TEdit;
    freqd: TEdit;
    calculpol: TButton;
    pol: TEdit;
    GroupBox5: TGroupBox;
    choixspectrebase: TComboBox;
    choixspectresig: TComboBox;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox6: TGroupBox;
    Fiter: TCheckBox;
    Label18: TLabel;
    FitBasMin: TEditReal;
    FitBasMax: TEditReal;
    Label19: TLabel;
    FitHauMin: TEditReal;
    FitHauMax: TEditReal;
    Label20: TLabel;
    Label21: TLabel;
    SousBase: TCheckBox;
    Fitdeg: TSpinEdit;
    Label23: TLabel;
    AffFit: TCheckBox;

    procedure choixspectredropdown(Sender: TObject);
    procedure ModeChange(Sender: TObject);
    procedure calculfiche(Sender: TObject);

    procedure initacquisition(freq,amp,niv:real);
    procedure acqui_brut(moyennage:integer;var result:brut512;var t:real);
    procedure acqui_spectre(npass,moyennage,indsig,indbase:integer;base:boolean;var temps:real);

    function  initundRMN(nom:string;freq,amp:real):integer;
    procedure bruttospectre1D(result:brut512;ind:integer);

    procedure  simple(npass,nvisu,moyennage:integer;nomsig,nombase:string;base:boolean;var temps,polar:real);
    procedure acquitemps(sender:Tobject);

    procedure formate(indsig,indbase,indresult:integer);
    function calcul_aire(ind:integer;freqgauche,freqdroite:real):real;
    procedure traitespectre(nomsig,nombase,nomresult:string; var polar:real);

    procedure scansyntheClick(Sender: TObject);
    procedure stopClick(Sender: TObject);
    procedure onsyntheClick(Sender: TObject);
    procedure offsyntheClick(Sender: TObject);
    procedure saturationClick(Sender: TObject);
    procedure runClick(Sender: TObject);
    procedure calculpolClick(Sender: TObject);
    procedure mesurepolar(n:integer;var polar,temps:real);
    Function  TestAcquis:boolean;

  private
    { Dclarations prives}
    resultbrut:brut512; {stocke les data brutes}
    stopflag,acquisitionRunning:boolean;
    freqencours,ampencours:real; {donne les valeurs en cours}
    compteur:integer; {donne le nbre de spectres acquis en mode f(t)}
  public
    { Dclarations publiques}
  end;

const
     dbytemin=-4730; {determine la valeur min de l'escalier de commande du synth
                     ici -1.5V}
     inc=37;{determine la hauteur des marches de tension}

var
  RMNacqui: TRMNacqui;

implementation

uses RMNbases, Graph1D, visu_polarisation, comptage2DTOF;

{$R *.DFM}
{*******************************************
procedures gnrales}
{*************************
}
procedure TRMNacqui.choixspectredropdown(Sender: TObject);
var i:integer;
begin
{reinitialisation des items des choixspectres a chaque ouverture du combo}
choixspectresig.items.clear;
choixspectrebase.items.clear;
sigpol.items.clear;
basepol.items.clear;
spectrepol.items.clear;

for i:=1 to totalspectre do
if und.spect[i]<>nil then
   begin
   choixspectresig.items.add(und.spect[i].nom);
   choixspectrebase.items.add(und.spect[i].nom);
   sigpol.items.add(und.spect[i].nom);
   basepol.items.add(und.spect[i].nom);
   spectrepol.items.add(und.spect[i].nom);
   end;
end;
{*************************
}
procedure TRMNacqui.ModeChange(Sender: TObject);
begin
if mode.text='Simple' then
   begin
   label4.visible:=false;
   repet.visible:=false;
   label6.visible:=false;
   nbrspectres.visible:=false;
   end
else
   begin
   label4.visible:=true;
   repet.visible:=true;
   label6.visible:=true;
   nbrspectres.visible:=true;
   end;
end;
{********************************************
calcul le temps necessaire  la mesure et la frequence du signal de balayage}
procedure TRMNacqui.calculfiche(Sender: TObject);
var T:real;
begin
t:=6.33*moy.value+1.2;
duree.text:=floattostr(npassage.value*t/1000);
freqmod.text:=floattostr(1000/t);
end;
{********************************************
*        procedures acquisition bas niveau
**********************************************}
{*********************************
initialise les cartes d'acquisitions et le synthe pour une acquisition}
procedure TRMNacqui.initacquisition(freq,amp,niv:real);
begin
stopflag:=false;
RMNbase.initchaine;
RMNbase.initsynthe(freq,amp,niv);
{RMNbase.syntheon;}
RMNbase.synthe_acquisition;
freqencours:=freq;
ampencours:=amp;
end;
{**************************
 ralise un passage avec le moyennage spcifi et donne le temps de
fin de comptage
INPUT moyennage: nombre d'acquisition par pas de frequence
OUPUT result: tableau 512*integer= donnes brutes
      t:temps en s }
procedure tRMNacqui.acqui_brut(moyennage:integer;
          var result:brut512;var t:real);

var  j:integer;
     dbyte:smallint;
     resultat:word;

begin

dbyte:=dbytemin;

for j:=1 to 256 do
         begin
           setdac1(dbyte);
           lecture(moyennage,resultat);
           dbyte:=dbyte+inc;
           result[j]:=resultat;
         end;

for j:=257 to 512 do
         begin
           dbyte:=dbyte-inc;
           setdac1(dbyte);
           lecture(moyennage,resultat);
           result[j]:=resultat;
         end;

t:=(time-int(time))*86400;  {temps en s}
end;
{***********************************************
realise un ensemble de npass passages avec au besoin la prise du spectre de base,
fait la conversion en mv et charge les spectres und
INPUT npass: nombre de passage a realiser
      moyennage : nombre d'acquisition par pas de frequence
      indsig,indbase : index des spectres recepteurs
      base : true si acquisition du signal de base}
procedure tRMNacqui.acqui_spectre(npass,moyennage,indsig,indbase:integer;base:boolean;var temps:real);
var  i:integer;
begin

{prise du signal}
i:=1;
while (i<=npass) and (stopflag=false) do
      begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
      und.spect[indsig].data[0,0,0].mon:=und.spect[indsig].data[0,0,0].mon+1;
      bruttospectre1D(resultbrut,indsig);
      i:=i+1;
      end;

{au besoin:prise du signal de base dans les meme conditions}
if base then
begin
RMNbase.sweepB('base');
{prise du signal de base}
i:=1;
while (i<=npass) and (stopflag=false) do
      begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
      und.spect[indbase].data[0,0,0].mon:=und.spect[indbase].data[0,0,0].mon+1;
      bruttospectre1D(resultbrut,indbase);
      i:=i+1;
      end;
RMNbase.sweepB('acquisition');
end;

end;
{********************************************
*        procedures acquisition haut niveau
**********************************************}
{************************************
acquisition simple = serie de  acqui_spectre  avec visualisation intermediaire
INPUT npass:nombre total de passage pour le spectre
      nvisu: nombre de passage entre chaque rafraichissement de la visu
      moyennage: moyennage de l'acquisition
      nomsig,nombase: nom des spectres recepteurs
      base: true si on veut faire l'acquisition du signal de base dans les meme conditions
OUTPUT temps: donne le temps de fin
       polar : donne la polar }
procedure  tRMNacqui.simple(npass,nvisu,moyennage:integer;nomsig,nombase:string;base:boolean;var temps,polar:real);
var i,indsig,indbase:integer;

begin

{initialisation des spectres}
indsig:=initundRMN(nomsig,freqencours,ampencours);
und.spect[indsig].comment:=datetostr(date)+' '+timetostr(time)+' '+'signal brut';
if base then
   begin
   indbase:=initundRMN(nombase,freqencours,ampencours);
   und.spect[indbase].comment:=datetostr(date)+' '+timetostr(time)+' '+'signal base';
   end;

acqui_spectre(npass,moyennage,indsig,indbase,base,temps);
{traitement}
if calpol.checked then
      traitespectre(nomsig,nombase,spectrepol.text,polar);
      {affichage}
if affichespe.checked then
      {graph1d.redessiner;}
      sendmessage(principalform.handle,wm_redessine,0,0);

{enregistrement}

end;
{************************************
acquisition f(t)
lance des simples rythms par le timer. l'ensemble des choix sont rinitialis  chaque fois}
procedure tRMNacqui.acquitemps(sender:Tobject);
var npass,nvisu,moyennage:integer;
    nomsig,nombase:string;
    temps,polar:real;

begin
timeracqui.enabled:=false;
timeracqui.interval:=repet.value;

if (comptage2DTOFform.status.caption='Acquisition') or (comptage2DTOFform.status.caption='Pause') or (not comptage2DTOFform.TestAcquis) then
begin
compteur:=compteur+1;
npass:=npassage.value;
moyennage:=moy.value;
nomsig:=choixspectresig.text;
nombase:=choixspectrebase.text;

simple(npass,nvisu,moyennage,nomsig,nombase,base.checked,temps,polar);

if calpol.checked then
   visupol.ajoute(temps,polar);
end;

{gestion fin d'acquisition}
if compteur<Nbrspectres.value then
   timeracqui.enabled:=true
else
   timeracqui.enabled:=false;

end;
{*************************************
stop tous les process}
procedure TRMNacqui.stopClick(Sender: TObject);
begin
stopflag:=true;
timeracqui.enabled:=false;
end;
{*****************************
*  partie transformation de rsultat
*
{*************************}
{*************************
verifie l'existance d'un spectre 1 D et l'initialise  pour une acquisition RMN
entre les frquences en fonction de freq et amp
INPUT nom:nom du spectre und
      freq:frequence centrale en MHz
      amp:amplitude de modulation en kHz}

function  tRMNacqui.initundRMN(nom:string;freq,amp:real):integer;
var ind,i:integer;
    deltaf:real;
begin
ind:=und.indexof(nom);
deltaf:=amp*1.02/1000; {conversion en MHz et correction de l'amplitude reel de balayage 2%}
{creation au besoin}
if ind=-1 then
   ind:=RMNbase.CreatespectreRMN(nom);

{initialisation}

und.spect[ind].data[0,0,0].mon:=0;    {designe le nbre de passages}
for i:=0 to 255 do
    und.spect[ind].data[i,0,0].x:=(freq-deltaf)+2*deltaf*i/255;
initundRMN:=ind;
end;
{********************************
effectue la conversion en mV, la superposition des parties montante et descendante,
et l'accumulation d'un signal brute dans un
spectre 1 D en fonction du nombre .mon de signal brute deja acquis}

procedure tRMNacqui.bruttospectre1D(result:brut512;ind:integer);

var i:integer;
    tampon,n:real;

begin
n:=und.spect[ind].data[0,0,0].mon; {nombre de spectres deja acquis}
for i:=0 to 255 do
    begin
    tampon:=(result[i+1]/(6.5536*RMNbase.gain)+result[512-i]/(6.5536*RMNbase.gain))/2; {conversion en mV et superposition}
    und.spect[ind].data[i,0,0].z:=(und.spect[ind].data[i,0,0].z*(n-1)+tampon)/n; {accumulation}
    end;
end;

{**************************

initialise les frequences de nomresult comme nomsig
Ralise ou la soustraction NomResult=NomSig-nombase  ou  NomResult=NomSig suivant le choix sousbase
Puis Fit NomResult par un polynome et effectue la soustraction du fit suivant le choix de Fiter }
procedure tRMNacqui.formate(indsig,indbase,indresult:integer);

var i,indfit,taille:integer;
    Xval,Yval,Coef:Tvec;


begin

{initialisation abscisse}
for i:=0 to 255 do
    und.spect[indresult].data[i,0,0].x:=und.spect[indsig].data[i,0,0].x;

{soustraction du signal de base}
if sousbase.checked then
for i:=0 to 255 do
    und.spect[indresult].data[i,0,0].z:=und.spect[indsig].data[i,0,0].z-und.spect[indbase].data[i,0,0].z
else
for i:=0 to 255 do
    und.spect[indresult].data[i,0,0].z:=und.spect[indsig].data[i,0,0].z;
    
{***  Fit }
if fiter.Checked then
begin
   if affFit.Checked then
   begin  {le Fit va etre stock dans le spectre Fit}
   indfit:=RMNbase.CreatespectreRMN('Fit');
   {initialisation abscisse}
   for i:=0 to 255 do
      und.spect[indfit].data[i,0,0].x:=und.spect[indsig].data[i,0,0].x;
   end;
   {cration des Vecteurs TVec}
   CreateIt(Xval,Yval,Coef);
   Xval.Size(256,false);
   Yval.Size(256,false);
   Coef.Size(Fitdeg.value+1,false);
   {initialisation des vecteurs}
   taille:=0;
   for i:=0 to 255 do
    if  ((FitBasMin.Value<und.spect[indresult].data[i,0,0].x) and (und.spect[indresult].data[i,0,0].x<FitBasMax.Value)) or
        ((FitHauMin.Value<und.spect[indresult].data[i,0,0].x) and (und.spect[indresult].data[i,0,0].x<FitHauMax.Value)) then
        begin
         Xval.values[taille]:=und.spect[indresult].data[i,0,0].x;
         yVal.values[taille]:=und.spect[indresult].data[i,0,0].z;
         taille:=taille+1;
        end;

   Xval.Size(taille,false);
   Yval.Size(taille,false);
   {Fit}
   polyfit(Xval,Yval,Fitdeg.value,coef);
   {initialisation du spectre Fit}
   if affFit.Checked then
     for i:=0 to 255 do
       und.spect[indfit].data[i,0,0].Z:=polyeval(und.spect[indfit].data[i,0,0].x,coef);
   {soustraction par le fit}
   if  affFit.Checked then
     for i:=0 to 255 do
        und.spect[indresult].data[i,0,0].z:=und.spect[indresult].data[i,0,0].z-und.spect[indfit].data[i,0,0].z
   else
     for i:=0 to 255 do
        und.spect[indresult].data[i,0,0].z:=und.spect[indresult].data[i,0,0].z-polyeval(und.spect[indresult].data[i,0,0].x,coef);
   {libration Tvec}
   FreeIt(Xval,Yval,Coef);
end; {fin du fit}


end;
{***********************
calcul l'aire d'un spectre en fonction des bornes choisies
Si l'option Fit n'est pas choisie, la fonction calcul la moyenne de la ligne de base a gauche et a droite du pic (correction ordre 0)
Si l'option Fit est choisie, la fonction calcul directement l'aire entre les borne avec une moyenne de la ligne de base Nullu       }
function tRMNacqui.calcul_aire(ind:integer;freqgauche,freqdroite:real):real;

var i,n:integer;
    tampon,resultat,ldb:real;


begin

tampon:=0;n:=0;
resultat:=0;
if Not Fiter.checked then
  begin {calcul de la moyenne de la base  gauche et a droite du spectre}
  for i:=0 to 255 do
    if (und.spect[ind].data[i,0,0].x<freqgauche) or (und.spect[ind].data[i,0,0].x>freqdroite) then
       begin
       tampon:=tampon+und.spect[ind].data[i,0,0].z;
       n:=n+1;
       end;

  ldb:=tampon/n;
  end
else
  ldb:=0;

{calcul par les trapezes de l'air entre le signal et la moyenne calcule}

for i:=0 to 255 do
    if (und.spect[ind].data[i,0,0].x>freqgauche) and (und.spect[ind].data[i,0,0].x<freqdroite) then
       resultat:=resultat+(2*ldb-und.spect[ind].data[i,0,0].z-und.spect[ind].data[i+1,0,0].z)/2;

calcul_aire:=-resultat;

end;

{**********************************************
traite le signal: fournit le spectre et calcul la polar.
si l'option translation base et choisie la procedure cherche par dichotomie la translation
minimisant l'ecart entre la partie gauche et droite du spectre}
procedure tRMNacqui.traitespectre(nomsig,nombase,nomresult:string; var polar:real);
var freqgauche,freqdroite:real;
    indresult,indsig,indbase:integer;


begin
indsig:=und.indexof(nomsig);
indbase:=und.indexof(nombase);
indresult:=und.indexof(nomresult);

{creation au besoin}
if indresult=-1 then
   indresult:=RMNbase.CreatespectreRMN(nomresult);

und.spect[indresult].comment:=datetostr(date)+' '+timetostr(time)+' '+'signal';

freqgauche:=strtofloat(freqg.text);
freqdroite:=strtofloat(freqd.text);


{soustraction signal moins base }
formate(indsig,indbase,indresult);

polar:=calcul_aire(indresult,freqgauche,freqdroite);

end;
{***************************
*     commande synthe}
{**************************************
realise un scan en frquence pour rglage}
procedure TRMNacqui.scansyntheClick(Sender: TObject);
var freq,amp,niv,temps:real;
    moyennage:integer;
begin
freq:=strtofloat(RMNbase.freqacq.text);
amp:=strtofloat(RMNbase.ampacq.text);
niv:=strtofloat(RMNbase.nivacq.text);
moyennage:=moy.value;


initacquisition(freq,amp,niv);

while not(stopflag) do
    begin
      Application.processMessages;
      acqui_brut(moyennage,resultbrut,temps);
    end;

end;
{***************************
}
procedure TRMNacqui.onsyntheClick(Sender: TObject);
var freq,amp,niv:real;
begin
freq:=strtofloat(RMNbase.freqacq.text);
amp:=strtofloat(RMNbase.ampacq.text);
niv:=strtofloat(RMNbase.nivacq.text);

initacquisition(freq,amp,niv);

RMNbase.syntheon;
end;
{***************************
}
procedure TRMNacqui.offsyntheClick(Sender: TObject);
begin
RMNbase.syntheoff;
end;
{***************************
}
procedure TRMNacqui.saturationClick(Sender: TObject);
begin
RMNbase.synthe_sature(strtofloat(tsat.text));
end;
{***************************
                RUN}
procedure TRMNacqui.runClick(Sender: TObject);
var freq,amp,niv,temps,polar:real;
begin
freq:=strtofloat(RMNbase.freqacq.text);
amp:=strtofloat(RMNbase.ampacq.text);
niv:=strtofloat(RMNbase.nivacq.text);
initacquisition(freq,amp,niv);

if mode.text='Simple' then
   begin
   simple(npassage.value,1,moy.value,choixspectresig.text,choixspectrebase.text,base.checked,temps,polar);
   pol.text:=floattostr(polar);
   end;
if mode.text='f(t)' then
   begin
   compteur:=0;
   if calpol.checked then
      visupol.clearvisu;
   timeracqui.interval:=50;
   timeracqui.enabled:=true;
   end;
end;
{***************************
traite le signal et calcul la polar}
procedure TRMNacqui.calculpolClick(Sender: TObject);
var polar:real;
begin
traitespectre(sigpol.text,basepol.text,spectrepol.text,polar);
pol.text:=floattostr(polar);
end;

{***************************
petite procedure calculant la polar en fonction des choix de la fiche
l'initialisation de l'acquisition doit etre faite au prealable}
procedure TRMNacqui.mesurepolar(n:integer;var polar,temps:real);

begin
acquisitionRunning:=true;
stopflag:=false;
simple(n,n,moy.value,choixspectresig.text,choixspectrebase.text,base.checked,temps,polar);
pol.text:=floattostr(polar);
acquisitionRunning:=false;

end;
{ function qui renvoi true si une acquisition est en route }
{ et false sinon                                           }
Function TRMNacqui.TestAcquis:boolean;
begin
     result:=acquisitionRunning;
end;
end.
