unit TTI3510;
{ unite de pilotage des alimentation TTI 10A              }
{ F. OTT, modifi le 27.10.99                             }

interface

uses GPIB_CEC;

const
     Vmax=35;
     Imax=10;

{ initialisation des alimentations }
Function Initialize_TTI3510(adresse:byte):integer;
{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: met la sortie de l'alimenation en pos active }
{         integer, code d'erreur                       }
Function SwitchON_TTI3510(adresse:byte):integer;
{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: met la sortie de l'alimenation en pos OFF    }
{         integer, code d'erreur                       }
Function SwitchOFF_TTI3510(adresse:byte):integer;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: real, valeur du courant                      }
Function GetCourant_TTI3510(adresse:byte):real;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: integer, code d'erreur                       }
Function SetCourant_TTI3510(adresse:byte;valeur:real):integer;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: real, valeur du courant                      }
Function GetTension_TTI3510(adresse:byte):real;
{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur de la tension VOLTS            }
{ OUTPUT: integer, code d'erreur                       }
Function SetTension_TTI3510(adresse:byte;valeur:real):integer;
{ passage en alim de tension }
{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: integer, code d'erreur                       }
Function SetToVoltageSource_TTI3510(adresse:byte):integer;
{ passage en alim de courant }
{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: integer, code d'erreur                       }
Function SetToCurrentSource_TTI3510(adresse:byte):integer;


implementation

{ initialisation des alimentations }
Function Initialize_TTI3510(adresse:byte):integer;
begin
result:=0;
end;

{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: met la sortie de l'alimenation en pos active }
{         integer, code d'erreur                       }
Function SwitchON_TTI3510(adresse:byte):integer;
begin
     GPIBsend(adresse,'OP 1');
result:=0;
end;

{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: met la sortie de l'alimenation en pos OFF    }
{         integer, code d'erreur                       }
Function SwitchOFF_TTI3510(adresse:byte):integer;
begin
     GPIBsend(adresse,'OP 0');
result:=0;
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: real, valeur du courant                      }
Function GetCourant_TTI3510(adresse:byte):real;
begin
result:=0;
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: integer, code d'erreur                       }
Function SetCourant_TTI3510(adresse:byte;valeur:real):integer;
var s:string;
begin
     str(valeur,s);     { writeln(s); }
     GPIBSend(adresse,'I '+s);
result:=0;
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur du courant en AMPERES          }
{ OUTPUT: real, valeur du courant                      }
Function GetTension_TTI3510(adresse:byte):real;
begin
result:=0;
end;

{ INPUT: adresse, adresse GPIB                         }
{        valeur, valeur de la tension VOLTS            }
{ OUTPUT: integer, code d'erreur                       }
Function SetTension_TTI3510(adresse:byte;valeur:real):integer;
var s:string;
begin
     str(valeur,s);
     { writeln(s); }
     GPIBSend(adresse,'V '+s);
result:=0;
end;

{ passage en alim de tension }
{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: integer, code d'erreur                       }
{ REMARK: on coupe la sortie quand on switch dans ce mode }
Function SetToVoltageSource_TTI3510(adresse:byte):integer;
begin
     SwitchOFF_TTI3510(adresse);
     SetTension_TTI3510(adresse,0);
     SetCourant_TTI3510(adresse,Imax);
result:=0;
end;
{ passage en alim de courant }
{ INPUT: adresse, adresse GPIB                         }
{ OUTPUT: integer, code d'erreur                       }
{ REMARK: on coupe la sortie quand on switch dans ce mode }
Function SetToCurrentSource_TTI3510(adresse:byte):integer;
begin
     SwitchOFF_TTI3510(adresse);
     SetCourant_TTI3510(adresse,0);
     SetTension_TTI3510(adresse,Vmax);
result:=0;     
end;

end.
