unit comptage2D;
{*******************************************
programme de pilotage de l'acquisition des neutrons en mode statique (fonctions simplifies)
{E.Leymarie 7/00
  MODIFICATIONS                                                                            }
{
                                                                         }
{ 10/00 legres modifications suite  l'installation du cable 3 bits,                      }
{       cette unit est utilisable seulement avec le cable sans dcalage                   }

{ 14/11/2000 (F. OTT) ajout d'une fonction AcqSimple2D                                              }
{ cela a entraine une modif de comptage2D pour disposer d'un flag et d'une fonction qui    }
{ indique si l'acquisition 2D est finie                                                    }
{ la fonction Operations.AcquisitionFinie court circuite la sauvegarde des spectres        }
{ et pose des problmes si elle est utilise par l'interpteur                           }

{ 28/11/00 :Edouard : modification de la procedure de rcupration des datas afin de ne pas}
{ perdre les spectres si ils portent le meme nom}

{17/01/01 : Edouard : modifications pour utilisation de l'index fichier
          creation de savespectre, destruction de testnomfich et d'objets sur la fiche}
{06/02/01: Edouard : correction bug  sur le flag acquisitionRunning en fin d'acquisition}
{27.03.01 :EL :modifications pour jumelage avec traitement:
               modification spectre.addspectre(X,Y) en spectre.addspectre(X,Y,1)

{11.06.01: EL: cration de la fonction Tcomptage2Dform.CreatePAPOLSpectre(nom:string):integer
               qui declare proprement des spectres pour PAPOL
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, Grids, ExtCtrls,Operations,editdata,BoiteNoire, Menus;
const
     wm_redessine=$403+wm_user;
     decalageencours=0; {indique le cable utilis}
type
  Tcomptage2Dform = class(TForm)
    parametres: TStringGrid;
    defTT: TSpinEdit;
    defTup: TSpinEdit;
    defTdown: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Choixspectreup: TComboBox;
    choixspectredown: TComboBox;
    Label6: TLabel;
    timeracquisition2D: TTimer;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    choixpolar: TComboBox;
    acquisition: TButton;
    previsualisation: TButton;
    stopbutton: TButton;
    PopupMenu1: TPopupMenu;
    rebootage: TMenuItem;
    Function TestAcquis:boolean;
    function CreatePAPOLSpectre(nom:string):integer;
    procedure FormCreate(Sender: TObject);
    procedure stop;
    procedure gestionfiche(sender:Tobject);
    procedure ChoixspectreClick(Sender: TObject);
    procedure savespectre(ind:integer;ext:string;var filename:string);

    procedure acquisition2D(TT,TU,TD:real;polar:string;indexspectreU,indexspectreD:integer);
    procedure TimeracquisitionTimer(Sender: TObject);
    procedure previsualisation2D;
    procedure acquisitionSimple2D(TT:integer);
    procedure acquisitionClick(Sender: TObject);
    procedure previsualisationClick(Sender: TObject);
    procedure stopbuttonClick(Sender: TObject);
    procedure rebootageClick(Sender: TObject);

  private
    { Dclarations prives}
    numerospectreU,numerospectreD:integer; {designe les spectres recepteurs}
    modepolar:string;
    stopflag:boolean;

  public
    { Dclarations publiques}
  end;

var
  comptage2Dform: Tcomptage2Dform;
  acquisitionRunning: boolean;

implementation

uses MainForm;

{$R *.DFM}
procedure Tcomptage2Dform.FormCreate(Sender: TObject);
var i:integer;
    filename:string;
begin
{initialisation du tableau parametreTOF}
parametres.cells[0,0]:='coups';
parametres.cells[1,0]:='moniteur';
parametres.cells[2,0]:='temps';

{cration de ACUP et ACDOWN}
CreatePAPOLSpectre('ACUP');
CreatePAPOLSpectre('ACDOWN');
{initialisation des items des choixspectre}
for i:=1 to totalspectre do
if deuxd.spect[i]<>nil then
begin
choixspectreup.items.add(deuxd.spect[i].nom);
choixspectredown.items.add(deuxd.spect[i].nom);
end;
choixspectreup.text:=deuxd.spect[1].nom;
choixspectredown.text:=deuxd.spect[2].nom;;


acquisitionRunning:=false;

end;
{ *****************************************
fonction qui cree un spectre au format PAPOL
*************}
function Tcomptage2Dform.CreatePAPOLSpectre(nom:string):integer;
var vind,i:integer;
begin
Vind:=deuxd.addspectre(nom,128,128,1);
deuxd.spect[vind].typex:='raw';
deuxd.spect[vind].typey:='raw';

for i:=0 to 127 do
    begin
    deuxd.spect[vind].data[i,i,1].x:=i;
    deuxd.spect[vind].data[i,i,1].y:=i;
    end;
result:=vind;
end;
{ *****************************************
  function qui renvoi true si une acquisition est en route }
{ et false sinon                                           }
Function Tcomptage2Dform.TestAcquis:boolean;
begin
     result:=acquisitionRunning;
end;


{********************************************
gestionfiche}
procedure Tcomptage2Dform.gestionfiche(sender:Tobject);

begin
if  choixpolar.text='UP' then
    begin
    defTup.enabled:=false;
    choixspectreup.enabled:=true;
    defTdown.enabled:=false;
    choixspectredown.enabled:=false;
    end;

if  choixpolar.text='DOWN' then
    begin
    defTup.enabled:=false;
    choixspectreup.enabled:=false;
    defTdown.enabled:=false;
    choixspectredown.enabled:=true;
    end;

if  choixpolar.text='UP/DOWN' then
    begin
    defTup.enabled:=true;
    choixspectreup.enabled:=true;
    defTdown.enabled:=true;
    choixspectredown.enabled:=true;
    end;
end;

{*******************************************
*}
procedure Tcomptage2Dform.ChoixspectreClick(Sender: TObject);
var i:integer;
begin
{initialisation a chaque ouverture des items des choixspectres}
choixspectreup.items.clear;
choixspectredown.items.clear;

for i:=1 to totalspectre do
    if deuxd.spect[i]<>nil then
       begin
       choixspectreup.items.add(deuxd.spect[i].nom);
       choixspectredown.items.add(deuxd.spect[i].nom);
       end;

end;
{*******************************************
procedure de sauvegarde des spectres : gestion de l'indexfichier et du nom de fichier (li  la boite noire)
INPUT ind : index du spectre  sauvegarder,
OUPUT filename : chemin+nom utilis pour la sauvegarde}
procedure Tcomptage2Dform.savespectre(ind:integer;ext:string;var filename:string);

begin
IncIndexFichierCrt; {incrementation de l'index fichier}
filename:=boitnoir.repertoiremanip.text+'\'+boitnoir.Edit2.text+inttostr(GetIndexFichierCrt)+'.'+ext;
deuxd.spect[ind].SetExpCond('Num',GetIndexFichierCrt);
deuxd.spect[ind].save(filename);
end;
{*******************************************
*           acquisition
******************************************* }
{*******************************************
*}
procedure Tcomptage2Dform.stop;
begin
operationform.suspendrecomptage;
stopflag:=true;
end;
{************************************************
lance une acquisition 2D polar independante des choix de la fiche
INPUT TT,TU,TD temps en s
      polar designe le mode UP DOWN ou UP/DOWN
      indexspectre designe le spectre recepteur
OUPUT implicite modepolar
                numerospectreU, numerospectreD
                }
procedure Tcomptage2Dform.acquisition2D(TT,TU,TD:real;polar:string;indexspectreU,indexspectreD:integer);
begin
operationform.LancerAcquisition2D(decalageencours,TT,TU,TD,polar);
timeracquisition2D.enabled:=true;

acquisitionRunning:=true;
stopflag:=false;
modepolar:=polar;
numerospectreU:=indexspectreU;
numerospectreD:=indexspectreD;
acquisition.enabled:=false;

{gestion de la boite noire}
boitnoir.receivetext(timetostr(time)+': acquisition '+floattostr(TT)+' '+polar+' TU:'+floattostr(TU)+' TD:'+floattostr(TD));
end;

{*******************************************
charge et affiche les parametres acquisition Moniteur, coups, temps
teste la fin de l'acquisition
lance la recuperation des donnees dans les spectres specifis par numerospectre
INPUT implicite numerospectreU
                numerospectreD
                modepolar
OUTPUT implicite affichage
                 spectres}

procedure Tcomptage2Dform.TimeracquisitionTimer(Sender: TObject);
var NT,NU,ND:cardinal;
    MT,MU,MD,TT,TU,TD:real;
    filename:string;
begin

operationform.litparametre2D(NT,NU,ND,MT,MU,MD,TT,TU,TD);

{test de l'ouverture du faisceau}
if (TT>0.5) and (TT<1.5) then
   if MT<5 then
      begin
      timeracquisition2D.enabled:=false;
      MessageDlg('ATTENTION : faisceau probablement ferm ', mtWarning,[mbOk],0);
      timeracquisition2D.enabled:=true;
      end;

if operationform.Acquisition2DFinie or stopflag then
   begin {fin de l'acquisition}

   timeracquisition2D.enabled:=false;

   {gestion de l'enregistrement et de la boite noire}
   boitnoir.receivetext(timetostr(time)+' fin acquisition TT='+floattostr(TT));
   if (modepolar='UP') or (modepolar='UP/DOWN') then
      begin
      operationform.LireSpectre2D(decalageencours,numerospectreU,numerospectreD,'UP',Datetostr(date)+', '+timetostr(time)+' Acq: '+modepolar+' '+' spectre UP');
      savespectre(numerospectreU,'2Du',filename);
      boitnoir.receivetext('spectre UP N='+inttostr(NU)+' M='+floattostr(MU)+' save to '+filename);
      end;
   if (modepolar='DOWN') or (modepolar='UP/DOWN') then
      begin
      operationform.LireSpectre2D(decalageencours,numerospectreU,numerospectreD,'DOWN',Datetostr(date)+', '+timetostr(time)+' Acq: '+modepolar+' '+' spectre DOWN');
      savespectre(numerospectreD,'2Dd',filename);
      boitnoir.receivetext('spectre DOWN N='+inttostr(ND)+' M='+floattostr(MD)+' save to '+filename);
      end;
   sendmessage(principalform.handle,wm_redessine,0,0);
   acquisitionRunning:=false;
   acquisition.enabled:=true;
   end;
   
parametres.cells[0,1]:=inttostr(NT);
parametres.cells[1,1]:=floattostr(MT);
parametres.cells[2,1]:=floattostr(TT);

parametres.cells[0,2]:=inttostr(NU);
parametres.cells[1,2]:=floattostr(MU);


parametres.cells[0,3]:=inttostr(ND);
parametres.cells[1,3]:=floattostr(MD);      


end;

{*******************************************
lance une prvisualisation
INPUT implicite polarisation, numeroframe, mode}
procedure Tcomptage2Dform.previsualisation2D;

begin
operationform.suspendrecomptage;
operationform.LireSpectre2D(decalageencours,numerospectreU,numerospectreD,modepolar,'PREVIEW');
operationform.reprendrecomptage;
sendmessage(principalform.handle,wm_redessine,0,0);
end;

{*******************************************
lancement d'une acquisition simple de TT seconde
les autres choix sont conformes a la fiche}
procedure Tcomptage2Dform.acquisitionSimple2D(TT:integer);
var  indUP,indDown:integer;
begin

indup:=deuxd.indexof(choixspectreup.text);
if indup=-1 then
   indup:=CreatePAPOLSpectre(choixspectreup.text);

inddown:=deuxd.indexof(choixspectredown.text);
if inddown=-1 then
   inddown:=CreatePAPOLSpectre(choixspectredown.text);

acquisition2D(TT,defTup.value,defTdown.value,choixpolar.text,indup,inddown);

end;


{***************************************
gestion des boutons}
procedure Tcomptage2Dform.acquisitionClick(Sender: TObject);

begin
acquisitionSimple2D(defTT.value);
end;
{***************************************}
procedure Tcomptage2Dform.previsualisationClick(Sender: TObject);
begin
previsualisation2D;
end;
{***************************************}
procedure Tcomptage2Dform.stopbuttonClick(Sender: TObject);
begin
stop;
end;

{************************************
permet de reprendre une acquisition apres plantage
les parametres de l'acquisition doivent etre mis a l'identiques}
procedure Tcomptage2Dform.rebootageClick(Sender: TObject);
var nomup,nomdown:string;
begin
nomup:=choixspectreup.text;
nomdown:=choixspectredown.text;
{test l'existance des spectres}
if deuxd.indexof(nomup)=-1 then
   CreatePAPOLSpectre(nomup);
if deuxd.indexof(nomdown)=-1 then
   CreatePAPOLSpectre(nomdown);

stopflag:=false;
modepolar:=choixpolar.text;
numerospectreU:=deuxd.indexof(nomup);
numerospectreD:=deuxd.indexof(nomdown);
acquisition.enabled:=false;
timeracquisition2D.enabled:=true;
end;

end.
